// =====================================================================================
//
//       Filename:  sql_lib_sample.c
//
//    Description:  
//                     code edit with vim and and tw=2, default code is under utf-8.
//
//        Version:  $Id$
//        Created:  2020/9/8 11:38:08
//       Revision:  none
//       Compiler:  modern c/c++ compiler, at least c++17 is requiment.
//                        ( test under gcc 8.3.0 and vs2019 ).
//
//         Author:  lk (dd), lk@shucantech.com
//				Company:  SCT
//   Organization:  SCT-P
//
//				License:  SCT-CL V0
//
// =====================================================================================

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "sql_lib.h"

void print_bymyself(void* d) {

  int r = (int)rows_of(d);
  int c = (int)cols_of(d);
  printf("\n");
  for (size_t i = 0; i < c; ++i) {
    int s = 0;
    const char* n = col_name(&s, d, (int)i);
    printf("%.*s ", s, n);
  }
  printf("\n");
  for (size_t i = 0; i < r; ++i) {
    for (size_t j = 0; j < c; ++j) {
      void* v = at(i, j, d);
      int g = val_sign(v); int s = val_size(v); int t = val_type(v);
      if (t == VAL_TYPE_I) {
        if (s == VAL_SIZE_1) {
          printf(" %d", (int)(g == VAL_SIGN ? as_int8(v) : as_uint8(v)));
        } else if (s == VAL_SIZE_2) {
          printf(" %d", (int)(g == VAL_SIGN ? as_int16(v) : as_uint16(v)));
        } else if (s == VAL_SIZE_4) {
          printf(" %d", (int)(g == VAL_SIGN ? as_int32(v) : as_uint32(v)));
        } else {
          printf(" %d", (int)(g == VAL_SIGN ? as_int64(v) : as_uint64(v)));
        }
      } else if (t == VAL_TYPE_F) {
        printf(" %f", s == VAL_SIZE_4 ? as_float(v) : as_double(v));
      } else if (t == VAL_TYPE_DT) {
        //print date.
      } else if (t == VAL_TYPE_S010){  //S004...
        char* p = NULL; uint64_t c = 0;
        as_str16(&p, &c, v);
        if( p != NULL ){ 
          printf(" %.*s", (int)c, p);
          free(p); 
        }
      } else {}
    }
    printf("\n");
  }
}

int main(int argc, char** argv) {
  if(!connect_to_server("192.168.0.103", 55555, "user", "user")){ return -1; }
  const char* s = "create table tab1 (id u32(true), name string16());";
  void* d = exec(s, (int)strlen(s));
  if (d == NULL) { printf("execute sql failed\n"); return 0; }
  del_datas(d);
  s = "insert into tab1 (id,name) select seq(1000), x2str16(seq(1000)+10);";
  d = exec(s, (int)strlen(s));
  if (d == NULL) { printf("execute sql failed\n"); return 0; }
  del_datas(d);
  s = "select id,name from tab1 where id < 10;";
  d = exec(s, (int)strlen(s));
  if( d == NULL ){ printf("execute sql failed\n"); return 0; }
  print(d);
  print_bymyself(d);
  del_datas(d);
  s = "drop table tab1;";
  d = exec(s, (int)strlen(s));
  exit_to_server();
  return 0;
}
