package com.sct;
import com.sct.*;

public class sct4j_sample {
  public static void main(String[] args)throws Exception {
    sct4j s = new sct4j();
    if(!s.connect_to_server("127.0.0.1", 55552, "user", "user")){
      System.out.printf("connect to server failed.\n");
      return;
    }

    String sql = "create table test_tab_by_java_sdk(id u32(true), id1 u08(true), id2 u16(true)" +
      "  , id3 u32(true), id4 u64(true), id5 i08(true), id6 i16(true), id7 i32(true)" +
      "  , id8 i64(true), v1 float(true), v2 double(true)" +
      "  , st1 string04(true)" +
      "  , st2 string08(true)" +
      "  , st3 string16(true)" +
      "  , st4 string32(true)" +
      "  , st5 string64(true)" +
      "  , st6 string128(true)" +
      "  , st7 string256(true)" +
      "  , d date(true)" +
      "  , t time(true)" +
      "  , dt datetime(true)" + ");";

    sct4j.dataset d = s.exec(sql);
    if(d != null ){ d.print(); } else { System.out.println("create test_tab_by_java_sdk failed\n"); return; }
    for(int i = 0; i < 100; ++i){
      float f = i;
      double v = f * f;
      sql = "insert into test_tab_by_java_sdk ( d, dt, id, id1, id2, id3, id4, id5, id6, id7, id8, st1, st2, st3, st4, st5, st6, st7, t, v1, v2 ) values ( \"2019-04-23\", \"2019-04-23 10:11:12.000\", "
        + String.valueOf(i) + ", 1, 2, 3, 4, -1, -2, -3, -4, \"abc\", \"abc\", \"abc\", \"abc\", \"abc\", \"abc\", \"abc\", \"18:00:00.000\", "
        + String.valueOf(f) + ", " + String.valueOf(v) + " );";
      d = s.exec(sql);
    }
    sql = "select * from test_tab_by_java_sdk";
    d = s.exec(sql);
    d.print();
    {
      int i = d.col_of("id");
      System.out.println(d.as_int(10, i));
    }
    {
      int i = d.col_of("id4");
      System.out.println(d.as_long(10, i));
    }
    {
      int i = d.col_of("id5");
      System.out.println(d.as_byte(10, i));
    }
    {
      int i = d.col_of("d");
      System.out.println(d.as_date(10, i));
    }
    {
      int i = d.col_of("dt");
      System.out.println(d.as_timestamp(10, i));
    }
    {
      int i = d.col_of("st2");
      System.out.println(d.as_string(10, i));
    }
    {
      int i = d.col_of("t");  //note, the time store as timestamp for store nanoseconds.
      System.out.println(d.as_timestamp(10, i));
    }
    {
      int i = d.col_of("v2");
      System.out.println(d.as_double(10, i));
    }

    sql = "fields_of test_tab_by_java_sdk";
    d = s.exec(sql);
    if(d != null ){ d.print(); }
    sql = "truncate test_tab_by_java_sdk";
    d = s.exec(sql);
    sql = "drop table test_tab_by_java_sdk";
    d = s.exec(sql);
    d.print();
    s.exit_to_server();
  }
}
